import argparse

"""
Implement your scanner inside the following class.
The scanning should be called through the function tokenize given below
Do not change the code outside of the following class
"""

class Scanner():
    pass

    def tokenize(self, string):
        """
        This function tokenizes a string to a list of tokens according to the rules defined by the list of regular expression

        Parameters:
            string(str): an arbitrary to tokenize

        Returns:
            Returns the list of tokens if the string is tokenizable by the set of regular expression
            Returns None when it is not possible
        """
        # change the return value according to your code
        return None

    # you may define other class methods here
    # ...




    # End of class Scanner

# Do not change the code below
# To call this script, execute the following command in your terminal
# python scanner.py my_regex.txt
# or depending on your python version, you might change it to
# python3.9 scanner.py my_regex.txt
if __name__ == "__main__":
    # !!! Do not change the code below !!!
    parser = argparse.ArgumentParser(
                    prog='Tokenizer')
    
    parser.add_argument('path_to_file')
    args = parser.parse_args()
    
    # read the test file and get tests
    path_to_file = args.path_to_file
    with open(path_to_file) as pf:
        file_content = pf.read()

    tests = file_content.split(
        "==============================================================================\n")[3].split(
        "--------------------------------\n")
    inputs = [t.split("\n")[0] for t in tests]
    outputs = [t.split("\n")[1] for t in tests]
    # scan strings
    scanning_results = {}
    scanner = Scanner()
    for t, o in zip(inputs, outputs):
        scanning_results[t] = scanner.tokenize(t)
        print("Input:          ", t)
        print("Your Output:    ", scanning_results[t])
        print("Expected output:", o)
        print()
    # write scanning results to the results file.
    import json
    with open("scan_results.json", "w") as sr:
        json.dump(scanning_results, sr)
