import argparse

"""
Implement your parser inside the following class.
The parsing should be called through the function parse given below
Do not change the code outside of the following class
"""

class GrammarParser():
    pass

    def parse(self, stmt_str):
        """
        This function parses a string and checks it against the given grammar

        Parameters:
            stmt_str(str): The string of the statement to parse. For a concrete example, see the file my_grammar.txt

        Returns:
            Returns True when the statement string is accepted by the grammar
            Returns False when the statement string is rejected by the grammar
        """
        # change the return value according to your code
        return False

    # you may define other class methods here
    # ...




    # End of class GrammarParser

# Do not change the code below
# To call this script, execute the following command in your terminal
# python parser.py my_grammar.txt
# or depending on your python version, you might call
# python3.9 parser.py my_grammar.txt
if __name__ == "__main__":
    # !!! Do not change the code below !!!
    parser = argparse.ArgumentParser(
                    prog='GrammarParser')
    
    parser.add_argument('path_to_file')
    args = parser.parse_args()
    
    # read the test file and get tests
    path_to_file = args.path_to_file
    with open(path_to_file) as pf:
        file_content = pf.read()

    grammar_txt = file_content.split("==============================================================================")[2]
    grammar_txt = "\n".join(grammar_txt.split("\n")[3:-1])
    tests = file_content.split(
        "==============================================================================\n")[3].split(
        "--------------------------------\n")
    inputs = [t.split("\n")[0] for t in tests]
    outputs = [t.split("\n")[1] for t in tests]
    # parse statements
    parsing_results = {}
    grammar_parser = GrammarParser()
    for t, o in zip(inputs, outputs):
        parsing_results[t] = grammar_parser.parse(t)
        print("Input:          ", t)
        print("Your Output:    ", parsing_results[t])
        print("Expected output:", o)
        print()
    # write parsing results to the results file.
    import json
    with open("parse_results.json", "w") as tr:
        json.dump(parsing_results, tr)
